/* GantChartWindowController */

#import <Cocoa/Cocoa.h>

#define SortByStartDate 0
#define SortByWorker    1
#define SortByName      2
#define SortByKind      3
@class MyTableView;
@class MYHeaderView;
@class MyContentsTableView;
@class IYPageInfo;
@class IYCsvConverter;
@interface GantChartWindowController : NSWindowController
{
    IBOutlet id o_ContentsContainerView;
    IBOutlet id o_ContentsDataSource;
    IBOutlet id o_SplitView;
    IBOutlet id o_TimeChartContainerView;
    IBOutlet id o_TimeChartDataSource;
    IBOutlet id o_TimeChartHeaderView;
		IBOutlet id o_magni;
		IBOutlet id o_reduct;
		IBOutlet id o_workerChoice;
    IBOutlet id o_defaultKind;         // v1.2
    IBOutlet id o_startDate;           // v1.2
		IBOutlet id o_sheet_window;
		//IBOutlet id o_sheet_startDate;   // v1.2
		IBOutlet id o_sheet_noOfColumns;
		IBOutlet id o_sheet_noOfRows;
		IBOutlet id o_sheet_attr_name;
		IBOutlet id o_sheet_attr_worker;
		IBOutlet id o_sheet_attr_startDate;
		IBOutlet id o_sheet_attr_finishDate;
		IBOutlet id o_sheet_attr_quantity;
		IBOutlet id o_sheet_attr_kind;
		IBOutlet id o_sheet_attr_progress;
		IBOutlet id o_sheet_attr_late;
		IBOutlet id o_sheet_attr_usedTime;
		IBOutlet id o_sheet_attr_efficient;
		IBOutlet id o_sheet_showOnBar;      // v1.4
		IBOutlet id o_sheet_maxRow;         // v1.4
		IBOutlet id o_sheet_maxColumn;      // v1.4

		IBOutlet id o_sortingsheet_window;
		IBOutlet id o_sortingsheet_rule;
		IBOutlet id o_sortingsheet_lineUp;

		IBOutlet NSButton* o_arrowButton; // v1.4
		IBOutlet NSButton* o_taskButton;  // v1.4
		IBOutlet NSButton* o_textButton;  // v1.4
		IBOutlet NSButton* o_lineButton;  // v1.4
		IBOutlet NSButton* o_timeButton;  // v1.4
		
		IBOutlet id				 o_printAccessoryWin;                 // v1.4
		IBOutlet id				 o_printAccessoryView;                // v1.4
		IBOutlet id        o_printAccessoryView_select;         // v1.4
		IBOutlet id        o_printAccessoryView_rowInPage;      // v1.4
		IBOutlet id        o_printAccessoryView_columnInPage;   // v1.4
		
		IBOutlet id        o_menu;                              // v1.4
	
    NSScrollView*         _contentsScrollView;
		NSScrollView*         _timeChartScrollView;
		MyContentsTableView*  _contentsTableView;
		MyTableView*          _timeChartTableView;
		NSCalendarDate*       _today;
		BOOL                  _curSelectedTool;

		int           _curSelectedCol;
		
		NSArray*      _toolButtons;							 // v1.4
		NSArray*      _toolButtonsOffImage;      // v1.4
		NSArray*      _toolButtonsMixedImage;		 // v1.4
		NSArray*      _toolButtonsLockImage;		 // v1.4
		NSArray*      _toolButtonsMode;          // v1.4
    		
}
- (IBAction)					chgScale:(id)sender;
- (IBAction)					chgStartDate:(id)sender;
- (void)							setupDocument:(id)sender;
- (IBAction)					setupDocumentOk:(id)sender;
- (IBAction)					setupDocumentCancel:(id)sender;
- (void)							showSortingRule:(id)sender;
- (IBAction)					sortingOk:(id)sender;
- (IBAction)					sortingCancel:(id)sender;
- (IBAction)					chgWorker:(id)sender;
- (void)							changeWorkerAction:(NSString*)selectItem;
- (void)							initContensCoulmn;
- (float)							contentColumnWidth:(NSString*)identifier;    //*** v1.1 addtion ***
- (float)							contentColumnMinWidth:(NSString*)identifier; //*** v1.4 addtion ***
- (void)							updateWorkerChoice;
- (void)							initSetupSheet;
- (void)							chartSlide:(NSCalendarDate*)newDate;       // v1.2
- (void)							chartMagni:(int)magni;
- (void)							didTimeChartColumnChg:(float)oldWidth:(float)newWidth;
- (NSTableView*)			timeChartTableView;
- (NSTableView*)			contentsTableView;
- (NSTableView*)			graphicView;
- (NSView*)     			timeChartHeaderView;
- (void)        			updateTimeChartHeaderView;
- (void)							setToday;
- (NSCalendarDate*)		today;
- (NSString*)					selectedWorker;
- (NSString*)					selectedKind;
- (float)							renderingPrintImageIn:(NSView*)renderingView pageInfo:(IYPageInfo*)pageInfo; // v1.4
- (void)							initRenderingContensCoulmn:(MyContentsTableView*)RenderingContensView;
- (void)							preferencesChanged:(id)notification;

- (void)							initToolButtons;                      // v1.4
- (IBAction)					selectToolAction:(id)sender;
- (Class)							currentGraphicClass;

- (BOOL)							selectedTool;
- (BOOL)							isSelectedArrow;
- (BOOL)							isSelectedTask;  // v1.4
- (void)							resetTool;
- (void)							changeToolMode;
- (void)							updateView;

- (NSView*)						printAccessoryView;                                                      // v1.4
- (void)							resetPrintAccessoryView;                                                 // v1.4
- (void)							prepareAccessoryView:(NSRange)rowColumnInPage;                           // v1.4
- (NSRange)						rowColumnInPage;                                                         // v1.4
- (IBAction)					selectPrintProcess:(id)sender;                                           // v1.4
- (int)								maxRow;                                                                  // v1.4
- (int)								maxColumn;                                                               // v1.4
- (int)								minRow;                                                                  // v1.4
- (int)								minColumn;																			                       	 // v1.4
- (IBAction)					openCSV:(id)sender;                                                      // v1.4
- (NSString*)					importCSV:(NSString*)csvData;                                            // v1.4
- (BOOL)							createTaskFromToken:(IYCsvConverter*)csvConverter atRowIndex:(int)index; // v1.4
- (NSCalendarDate*)		dateFromToken:(NSString*)token;                                          // v1.4
@end

extern NSString *selectedToolDidChangeNotification;
extern NSString* ContentsRow_Drag;                                   // v1.4

