/* MyTableView */

#import <Cocoa/Cocoa.h>
@class GantChartWindowController;
@class iGantDoc;
@class iGNTGraphic;
@class iGNTTask;
@class iGNTWorker;

#define iGNT_HALF_HANDLE_WIDTH 3.5
#define iGNT_HANDLE_WIDTH (iGNT_HALF_HANDLE_WIDTH * 2.0)

@interface MyTableView : NSTableView
{
	GantChartWindowController*     _controller;
	NSMutableArray*                _selectedGraphics;
	iGNTGraphic*                   _creatingGraphic;
	NSRect                         _rubberbandRect;
	//NSSet*                         _rubberbandGraphics;
	NSMutableArray*								 _rubberbandGraphics;
	iGNTGraphic*                   _editingGraphic;
  iGNTGraphic*                   _relationGraphic;      // v1.2
	NSView*                        _editorView;
	int                            _pasteCascadeNumber;
	NSPoint                        _clickPoint;
	NSTimer*                       _unhideKnobsTimer;
	struct __gvFlags {
		unsigned int rubberbandIsDeselecting:1;
		unsigned int knobsHidden:1;
		unsigned int _pad:27;
	}                              _gvFlags;
	NSRect                         _verticalRulerLineRect;
	NSRect                         _horizontalRulerLineRect;
	BOOL                           _resizeColumnFlg;
	NSRect                         _relationLinerect;
	NSPoint                        _rerationStartPoint;
	NSPoint                        _rerationEndPoint;
	//BOOL                           _showRelation;
	//BOOL                           _showZigzag;

	//*** Geometry calculations Support
	NSMutableDictionary*           _cellGraphics;
	NSMutableDictionary*           _rowGraphics;
  
  float                          _liveResizeing; // v1.2
	NSPoint                        _chartTop;      // v1.4 for Printing
	BOOL                           _isForPrinting; // v1.4 for Printing
	BOOL                           _isMoveing;     // v1.4
}

// SKTDrawWindowController accessors and convenience methods
- (void)												setDrawWindowController:(GantChartWindowController *)theController;
- (GantChartWindowController *)	drawWindowController;
- (iGantDoc *)									drawDocument;
- (NSArray *)										graphics;
- (NSArray *)										graphicsInSelectedWorker:(NSArray*)source;
- (NSArray *)										graphicsInRow:(int)rowNo selectClass:(Class)class;
- (NSArray *)										graphicsInRowSelectedWorker:(int)rowNo selectClass:(Class)class;
- (iGNTTask*)										targetGraphicInRow:(int)rowNo;

// methods for optimize.bundle
- (NSArray *)										tasksInRow:(int)rowNo;
- (NSArray *)										tasksIsSelected:(BOOL)flg;

	// Display invalidation
- (void)												invalidateGraphic:(iGNTGraphic *)graphic;
- (void)												setundoDisplay:(BOOL)flag;
	// Selection primitives
- (NSArray *)										selectedGraphics;
- (NSArray *)										orderedSelectedGraphics;
- (BOOL)												graphicIsSelected:(iGNTGraphic *)graphic;
- (void)												selectGraphic:(iGNTGraphic *)graphic;
- (void)												selectGraphicAction:(iGNTGraphic *)graphic;
- (void)												deselectGraphic:(iGNTGraphic *)graphic;
- (void)												deselectGraphicAction:(iGNTGraphic *)graphic;
- (void)												clearSelection;

	// Managing editoring graphics
- (void)												setEditingGraphic:(iGNTGraphic *)graphic editorView:(NSView *)editorView;
- (iGNTGraphic *)								editingGraphic;
- (NSView *)										editorView;
- (void)												startEditingGraphic:(iGNTGraphic *)graphic withEvent:(NSEvent *)event;
- (void)												endEditing;
	// Geometry calculations Support
- (void)												makeupGraphics_2D;
- (void)												setGraphics_2D:(iGNTGraphic *)graphic;
- (void)												setGraphics_2D_noUndo:(iGNTGraphic *)graphic;
- (void)												removeGraphics_2D:(iGNTGraphic *)graphic;
- (void)												removeGraphics_2D_noUndo:(iGNTGraphic *)graphic;

- (NSArray *)										graphicsInColumn:(int)column row:(int)row;

	// Geometry calculations
- (iGNTGraphic *)								graphicUnderPoint:(NSPoint)point;
- (NSMutableArray*)							graphicsIntersectingRect:(NSRect)rect selectWorker:(BOOL)flg;
- (NSCalendarDate*) 						point_xToDate:(float)point_x;
- (float)												dateToPoint_x:(NSCalendarDate*)date;
- (int)													point_yToRow:(float)point_y;
- (BOOL)												isInsidePoint:(NSPoint)point;     // v1.4
- (NSCalendarDate*) 						adjustDate:(NSCalendarDate*)date direction:(int)direction; // v1.4
	// Drawing and mouse tracking
- (void)												drawRect:(NSRect)rect;
- (void)												drawContents :(NSRect)rect;
- (void)												drawingZigzag:(NSRect)rect;
  // For Printing v1.4
- (void)												setChartTop:(NSPoint)topPoint;
- (NSPoint)											chartTop;

- (void)												createGraphicOfClass:(Class)theClass withEvent:(NSEvent *)theEvent;
- (void)												createTsdkByName:(NSString*)name InRow:(int)rowIndex;  // v1.4
- (iGNTGraphic *)								creatingGraphic;
- (void)												trackKnob:(int)knob ofGraphic:(iGNTGraphic *)graphic withEvent:(NSEvent *)theEvent;
- (void)												setTaskIndicatorofGraphic:(iGNTGraphic *)graphic WithEvent:(NSEvent *)theEvent;
- (void)												setTaskRelation:(iGNTGraphic *)graphic WithEvent:(NSEvent *)theEvent;
- (void)												rubberbandSelectWithEvent:(NSEvent *)theEvent;
- (void)												moveSelectedGraphicsWithEvent:(NSEvent *)theEvent;
- (void)												selectAndTrackMouseWithEvent:(NSEvent *)theEvent;
- (void)												mouseDown:(NSEvent *)theEvent;
- (void)												didChartSlide;
- (void)												didChartMagni;
- (void)												solveOverlap;
- (void)												sortingTask:(int)rule LineUp:(int)status;
- (void)												alignmentRelation;
- (BOOL)												cancelDupli;  // v1.4
- (BOOL)												alignment;    // v1.4

- (BOOL)												isShowRelation;
- (BOOL)												isShowZigzag;
- (Byte)												isShowOnBar;  // v1.4
- (BOOL)                        isMoveing;    // v1.4
//- (void)												setShowRelation:(BOOL)flag;   // v1.2 - v1.3.2
//- (void)												setShowZigzag:(BOOL)flag;     // v1.2 - v1.3.2

	// Dragging
- (unsigned int)								dragOperationForDraggingInfo:(id <NSDraggingInfo>)sender;
- (unsigned int)								draggingEntered:(id <NSDraggingInfo>)sender;
- (unsigned int)								draggingUpdated:(id <NSDraggingInfo>)sender;
- (void)												draggingExited:(id <NSDraggingInfo>)sender;
- (BOOL)												prepareForDragOperation:(id <NSDraggingInfo>)sender;
- (BOOL)												performDragOperation:(id <NSDraggingInfo>)sender;
- (void)												concludeDragOperation:(id <NSDraggingInfo>)sender;

  // manage resizeColumn
- (BOOL)												resizeColumnFlg;
- (void)												setResizeColumnFlg:(BOOL)flg;
- (float)												curColumnWidth;								  // v1.4
	// Action methods and other UI entry points
//- (void)												changeColor:(id)sender;

- (IBAction)	toggleRuler:(id)sender;
- (IBAction)	selectAll:(id)sender;
- (IBAction)	deselectAll:(id)sender;
- (IBAction)	delete:(id)sender;
- (IBAction)	bringToFront:(id)sender;
- (IBAction)	sendToBack:(id)sender;
- (IBAction)	alignLeftEdges:(id)sender;
- (IBAction)	alignRightEdges:(id)sender;
- (IBAction)	alignTopEdges:(id)sender;
- (IBAction)	alignBottomEdges:(id)sender;
- (IBAction)	alignHorizontalCenters:(id)sender;
- (IBAction)	alignVerticalCenters:(id)sender;
- (IBAction)	makeSameWidth:(id)sender;
- (IBAction)	makeSameHeight:(id)sender;
- (IBAction)	makeNaturalSize:(id)sender;
- (IBAction)	snapsToDateMenuAction:(id)sender;
- (IBAction)	showRelation:(id)sender;
- (IBAction)	showZigzag:(id)sender;
- (IBAction)	drawZigzag:(id)sender;
- (void)			drawZigzagAction:checkDate;
- (IBAction)	stretchZigzag:(id)sender;
- (IBAction)	setHoliday:(id)sender;
- (void)			setProjectsHoriday:(NSCalendarDate *)holiday;
- (void)			setWorkersHoriday:(NSCalendarDate *)holiday workerName:(NSString*)name;
- (IBAction)	setAttendance:(id)sender;
- (void)			setProjectsAttendance:(NSCalendarDate *)attendance;
- (void)			setWorkersAttendance:(NSCalendarDate *)attendance workerName:(NSString*)name;
- (IBAction)	changeRow:(id)sender;
- (IBAction)	insertRow:(id)sender;
- (void)			insertRowAction:(int)selectedRow;
- (IBAction)	deleteRow:(id)sender;
- (void)			deleteRowAction:(int)selectedRow;
- (IBAction)	setTaskRelation:(id)sender;

@end

extern NSString *GraphicViewSelectionDidChangeNotification;

