//
//  iGantDoc.h
//  PROJECTNAME
//
//  Created by FULLUSERNAME on DATE.
//  Copyright (c) 2001 ORGANIZATIONNAME. All rights reserved.
//


#import <Cocoa/Cocoa.h>
#define WeeklyChart  0
#define DayChart     1
#define HalfDayChart 2
#define HourChart    3

@class iGNTGraphic;
@class IYWindowInfo;
@class iGNTTask;
@interface iGantDoc : NSDocument{

	@private
	//*** document data ***
	NSMutableArray *_graphics;

	int             _noOfRows;
	int             _noOfColumns;
	int             _unitOfColumn;
	NSCalendarDate* _startDate;
	NSMutableArray* _contentsColumns;
	NSMutableArray* _zigzag;
	int             _nextWorkerNo;
	NSMutableArray* _workers;
  NSMutableArray* _deletedWorkers; // v1.2 addtion
	NSMutableArray* _projectsHoliday;
	NSMutableArray* _projectsAttendance;
	NSString*       _selectedWorker;
	float           _columnWidth;
  //*** v1.1 addtion ***
  IYWindowInfo*        _windowInfo;
  NSMutableDictionary* _contentsWidth;
	//*** v1.4 addtion ***
	NSRange              _rowColumnInPage;
}
- (id)init;

- (void)makeWindowControllers;
- (NSDictionary *)drawDocumentDictionary;

- (NSData *)			drawDocumentDataForGraphics:(NSArray *)graphics;

- (NSRect)				boundsForGraphics:(NSArray *)graphics;
- (NSRect)				drawingBoundsForGraphics:(NSArray *)graphics;
- (NSData *)			CSVRepresentationForTasks;                                         // v1.4
- (void)					task:(iGNTTask*)sourceTask tokenizeTo:(NSMutableArray*)tokenArray; // v1.4

- (NSData *)			dataRepresentationOfType:(NSString *)type;
- (BOOL)					loadDataRepresentation:(NSData *)data ofType:(NSString *)type;

- (void)					setRowColumnInPage:(NSRange)rowColumnInPage;  // v1.4
- (NSArray*)			pageInfos;                                    // v1.4
- (void)					printShowingPrintPanel:(BOOL)flag;

- (NSArray *)			graphics;
- (void)					setGraphics:(NSArray *)graphics;
- (void)					invalidateGraphic:(iGNTGraphic *)graphic;
- (void)					insertGraphic:(iGNTGraphic *)graphic atIndex:(unsigned)index;
- (void)					removeGraphicAtIndex:(unsigned)index;
- (void)					removeGraphic:(iGNTGraphic *)graphic;
- (void)					moveGraphic:(iGNTGraphic *)graphic toIndex:(unsigned)newIndex;
    // Returns usable document size based on print info paper size and margins.

- (int)							maxRow;                                                                  // v1.4
- (int)							maxColumn;                                                               // v1.4
- (int)							minRow;                                                                  // v1.4
- (int)							minColumn;																			                       	 // v1.4
- (int)							noOfRows;
- (void)						setNoOfRows_noUndo:(int)no;
- (void)						setNoOfRows:(int)no;
- (int)							noOfColumns;
- (void)						setNoOfColumns:(int)no;
- (int)							unitOfColumn;
- (void)						setUnitOfColumn:(int)unit;
- (NSCalendarDate*)	startDate;
- (void)						setStartDate:(NSCalendarDate *)date;
- (void)						setContentsColumns:(NSMutableArray*) contents;
- (NSMutableArray*)	contentsColumns;
- (void)						setZigzag:(NSMutableArray*)zigzag;
- (NSMutableArray*)	zigzag;
- (BOOL)						setZigzagdate:(NSCalendarDate *)date;  // v1.4
- (void)						setNextWorkerNo:(int)no;
- (int)							nextWorkerNo;
- (void)						setWorkers:(NSMutableArray*)workers;
- (void)						setDeletedWorkers:(NSMutableArray*)workers;
- (NSMutableArray*)	workers;
- (NSMutableArray*)	deletedWorkers;
- (NSArray*)				efficientOrderWorkers:(NSString*)kind;
- (NSMutableArray*)	projectsHoliday;
- (void)						setProjectsHoriday:(NSCalendarDate *)holiday;
- (void)						reflectHoliday;
- (void)						setWorkersHoriday:(NSCalendarDate *)holiday workerName:(NSString*)name;
- (NSArray*)				getHoliday:(NSString*)workerName;
- (NSMutableArray*)	projectsAttendance;
- (void)						setProjectsAttendance:(NSCalendarDate *)attendance;
- (void)						setWorkersAttendance:(NSCalendarDate *)attendance workerName:(NSString*)name;
- (NSArray*)				getAttendance:(NSString*)workerName;
- (void)						setSelectedWorker:(NSString*)selectedWorker;
- (NSString*)				selectedWorker;
- (void)						setColumnWidth:(float)columnWidth;
- (float)						columnWidth;
- (BOOL)						isContainSameName:(NSString*)name;            // v1.3.1 addtion
//*** v1.1 addtion ***
- (IYWindowInfo*)				windowInfo;
- (void)								setWindowInfo:(IYWindowInfo*)windowInfo;
- (NSMutableDictionary*)contentsWidth;
//***
	// Action methods and other UI entry points
- (void)setupDocument:(id)sender;



@end

extern NSString *iGantDocType;
extern NSString *csvFormat;

